=== modified file 'DBUS-API'
--- DBUS-API	2011-11-26 23:08:17 +0000
+++ DBUS-API	2011-10-02 19:18:24 +0000
@@ -112,7 +112,7 @@
       Disable().
    
    f) The date and time this client will be disabled, as an RFC 3339
-      string, or an empty string if this is not scheduled.
+      string, or an empty string if this has not happened.
    
    g) The date and time of the last approval request, as an RFC 3339
       string, or an empty string if this has not happened.
@@ -152,9 +152,6 @@
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
-*** NewRequest(s: IP address)
-    A client at IP adress has asked for its password.
-
 * Copyright
 
     Copyright © 2010-2011 Teddy Hogeborn

=== modified file 'Makefile'
--- Makefile	2011-12-21 00:33:12 +0000
+++ Makefile	2011-11-28 22:15:04 +0000
@@ -26,16 +26,12 @@
 version=1.4.1
 SED=sed
 
-USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
-GROUP=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nobody || echo 65534)))
-
 ## Use these settings for a traditional /usr/local install
 # PREFIX=$(DESTDIR)/usr/local
 # CONFDIR=$(DESTDIR)/etc/mandos
 # KEYDIR=$(DESTDIR)/etc/mandos/keys
 # MANDIR=$(PREFIX)/man
 # INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
-# STATEDIR=$(DESTDIR)/var/lib/mandos
 ##
 
 ## These settings are for a package-type install
@@ -44,7 +40,6 @@
 KEYDIR=$(DESTDIR)/etc/keys/mandos
 MANDIR=$(PREFIX)/share/man
 INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
-STATEDIR=$(DESTDIR)/var/lib/mandos
 ##
 
 GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
@@ -235,7 +230,7 @@
 distclean: clean
 mostlyclean: clean
 maintainer-clean: clean
-	-rm --force --recursive keydir confdir statedir
+	-rm --force --recursive keydir confdir
 
 check:	all
 	./mandos --check
@@ -265,8 +260,13 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	./mandos --debug --no-dbus --configdir=confdir \
-		--statedir=statedir $(SERVERARGS)
+	@echo "#################################################################"
+	@echo "# NOTE: Please IGNORE the error about \"Could not open file      #"
+	@echo "# u'/var/run/mandos.pid'\" -  it is harmless and is caused by    #"
+	@echo "# the server not running as root.  Do NOT run \"make run-server\" #"
+	@echo "# server as root if you didn't also unpack and compile it thus. #"
+	@echo "#################################################################"
+	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server
 confdir/mandos.conf: mandos.conf
@@ -277,8 +277,6 @@
 	install --mode=u=rw $< $@
 # Add a client password
 	./mandos-keygen --dir keydir --password >> $@
-statedir:
-	install --directory statedir
 
 install: install-server install-client-nokey
 
@@ -289,8 +287,6 @@
 
 install-server: doc
 	install --directory $(CONFDIR)
-	install --directory --mode=u=rwx --owner=$(USER) \
-		--group=$(GROUP) $(STATEDIR)
 	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-ctl

=== modified file 'TODO'
--- TODO	2011-12-25 00:43:51 +0000
+++ TODO	2011-11-28 00:27:49 +0000
@@ -1,10 +1,14 @@
 -*- org -*-
 
+* Use _attribute_((nonnull)) wherever possible.
+
 * [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
 
 * mandos-applet
 
 * mandos-client
+** TODO [#B] Flag fprintf_plus so compiler checks the format string.
+** TODO [#A] OpenVPN network hook
 ** TODO [#A] Wireless network hook
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use struct sockaddr_storage instead of a union
@@ -39,20 +43,24 @@
 ** TODO [#B] Use openat()
 
 * mandos (server)
-** TODO Document why we ignore sigint
 ** TODO [#B] Log level							  :BUGS:
+** TODO Persistent state						  :BUGS:
+   /var/lib/mandos/*
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
-** TODO Log level dbus option
-   SetLogLevel D-Bus call
+** TODO Log level option
+   syslogger.setLevel(logging.WARNING)
+   + SetLogLevel D-Bus call
 ** TODO Implement --foreground						  :BUGS:
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
+** TODO Date+time on console log messages				  :BUGS:
+   Is this the default?
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
-** TODO [#B] By-client countdown on number of secrets given
+** TODO [#B] By-client countdown on secrets given
 ** TODO [#B] Support RFC 3339 time duration syntax
 ** More D-Bus methods
 *** NeedsPassword(50) - Timeout, default disapprove
@@ -63,6 +71,7 @@
    http://0pointer.de/blog/projects/systemd.html
    http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
+** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
 ** TODO Generate Client.runtime_expansions from client options + extra
@@ -77,6 +86,7 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
+** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with

=== modified file 'clients.conf'
--- clients.conf	2011-11-26 23:08:17 +0000
+++ clients.conf	2011-09-19 09:42:55 +0000
@@ -30,9 +30,6 @@
 # How long one approval will last.
 ;approval_duration = 1s
 
-# Whether this client is enabled by default
-;enabled = True
-
 
 ;####
 ;# Example client

=== modified file 'debian/control'
--- debian/control	2011-12-21 17:09:12 +0000
+++ debian/control	2011-10-11 19:36:00 +0000
@@ -17,8 +17,7 @@
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.7) | python-argparse,
-	python-gnupginterface
+	python-urwid, python (>=2.7) | python-argparse
 Recommends: fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
@@ -38,7 +37,7 @@
 Package: mandos-client
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2), initramfs-tools
+	gnupg (<< 2)
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system

=== modified file 'debian/mandos.dirs'
--- debian/mandos.dirs	2011-11-26 22:22:20 +0000
+++ debian/mandos.dirs	2010-09-15 17:33:14 +0000
@@ -4,4 +4,3 @@
 etc/default
 etc/dbus-1/system.d
 usr/sbin
-var/lib/mandos

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2011-11-26 22:22:20 +0000
+++ debian/mandos.postinst	2011-10-10 20:29:58 +0000
@@ -35,12 +35,11 @@
 		--disabled-password --gecos "Mandos password system" \
 		_mandos
 	fi
-	chown _mandos:_mandos /var/lib/mandos
 	;;
-    
+
     abort-upgrade|abort-deconfigure|abort-remove)
 	;;
-    
+
     *)
 	echo "$0 called with unknown argument '$1'" 1>&2
 	exit 1

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2011-11-29 18:19:31 +0000
+++ initramfs-tools-hook	2011-11-28 22:34:10 +0000
@@ -107,16 +107,6 @@
     esac
 done
 
-# Get DEVICE from initramfs.conf and other files
-. /etc/initramfs-tools/initramfs.conf
-for conf in /etc/initramfs-tools/conf.d/*; do
-    if [ -n `basename \"$conf\" | grep '^[[:alnum:]][[:alnum:]\._-]*$' \
-	| grep -v '\.dpkg-.*$'` ]; then
-	[ -f ${conf} ] && . ${conf}
-    fi
-done
-export DEVICE
-
 # Copy network hooks
 for hook in /etc/mandos/network-hooks.d/*; do
     case "`basename \"$hook\"`" in

=== modified file 'mandos'
--- mandos	2011-12-23 20:00:52 +0000
+++ mandos	2011-10-15 16:48:03 +0000
@@ -63,8 +63,6 @@
 import cPickle as pickle
 import multiprocessing
 import types
-import binascii
-import tempfile
 
 import dbus
 import dbus.service
@@ -75,7 +73,6 @@
 import ctypes.util
 import xml.dom.minidom
 import inspect
-import GnuPGInterface
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -85,128 +82,24 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
+
 version = "1.4.1"
-stored_state_file = "clients.pickle"
 
-logger = logging.getLogger()
+#logger = logging.getLogger('mandos')
+logger = logging.Logger('mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = str("/dev/log")))
-
-try:
-    if_nametoindex = (ctypes.cdll.LoadLibrary
-                      (ctypes.util.find_library("c"))
-                      .if_nametoindex)
-except (OSError, AttributeError):
-    def if_nametoindex(interface):
-        "Get an interface index the hard way, i.e. using fcntl()"
-        SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-        with contextlib.closing(socket.socket()) as s:
-            ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                struct.pack(str("16s16x"),
-                                            interface))
-        interface_index = struct.unpack(str("I"),
-                                        ifreq[16:20])[0]
-        return interface_index
-
-
-def initlogger(debug, level=logging.WARNING):
-    """init logger and add loglevel"""
-    
-    syslogger.setFormatter(logging.Formatter
-                           ('Mandos [%(process)d]: %(levelname)s:'
-                            ' %(message)s'))
-    logger.addHandler(syslogger)
-    
-    if debug:
-        console = logging.StreamHandler()
-        console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
-                                               ' [%(process)d]:'
-                                               ' %(levelname)s:'
-                                               ' %(message)s'))
-        logger.addHandler(console)
-    logger.setLevel(level)
-
-
-class PGPError(Exception):
-    """Exception if encryption/decryption fails"""
-    pass
-
-
-class PGPEngine(object):
-    """A simple class for OpenPGP symmetric encryption & decryption"""
-    def __init__(self):
-        self.gnupg = GnuPGInterface.GnuPG()
-        self.tempdir = tempfile.mkdtemp(prefix="mandos-")
-        self.gnupg = GnuPGInterface.GnuPG()
-        self.gnupg.options.meta_interactive = False
-        self.gnupg.options.homedir = self.tempdir
-        self.gnupg.options.extra_args.extend(['--force-mdc',
-                                              '--quiet'])
-    
-    def __enter__(self):
-        return self
-    
-    def __exit__ (self, exc_type, exc_value, traceback):
-        self._cleanup()
-        return False
-    
-    def __del__(self):
-        self._cleanup()
-    
-    def _cleanup(self):
-        if self.tempdir is not None:
-            # Delete contents of tempdir
-            for root, dirs, files in os.walk(self.tempdir,
-                                             topdown = False):
-                for filename in files:
-                    os.remove(os.path.join(root, filename))
-                for dirname in dirs:
-                    os.rmdir(os.path.join(root, dirname))
-            # Remove tempdir
-            os.rmdir(self.tempdir)
-            self.tempdir = None
-    
-    def password_encode(self, password):
-        # Passphrase can not be empty and can not contain newlines or
-        # NUL bytes.  So we prefix it and hex encode it.
-        return b"mandos" + binascii.hexlify(password)
-    
-    def encrypt(self, data, password):
-        self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull) as devnull:
-            try:
-                proc = self.gnupg.run(['--symmetric'],
-                                      create_fhs=['stdin', 'stdout'],
-                                      attach_fhs={'stderr': devnull})
-                with contextlib.closing(proc.handles['stdin']) as f:
-                    f.write(data)
-                with contextlib.closing(proc.handles['stdout']) as f:
-                    ciphertext = f.read()
-                proc.wait()
-            except IOError as e:
-                raise PGPError(e)
-        self.gnupg.passphrase = None
-        return ciphertext
-    
-    def decrypt(self, data, password):
-        self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull) as devnull:
-            try:
-                proc = self.gnupg.run(['--decrypt'],
-                                      create_fhs=['stdin', 'stdout'],
-                                      attach_fhs={'stderr': devnull})
-                with contextlib.closing(proc.handles['stdin'] ) as f:
-                    f.write(data)
-                with contextlib.closing(proc.handles['stdout']) as f:
-                    decrypted_plaintext = f.read()
-                proc.wait()
-            except IOError as e:
-                raise PGPError(e)
-        self.gnupg.passphrase = None
-        return decrypted_plaintext
-
-
+syslogger.setFormatter(logging.Formatter
+                       ('Mandos [%(process)d]: %(levelname)s:'
+                        ' %(message)s'))
+logger.addHandler(syslogger)
+
+console = logging.StreamHandler()
+console.setFormatter(logging.Formatter('%(name)s [%(process)d]:'
+                                       ' %(levelname)s:'
+                                       ' %(message)s'))
+logger.addHandler(console)
 
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
@@ -271,6 +164,10 @@
                             .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
+        syslogger.setFormatter(logging.Formatter
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
+                                % self.name))
         self.remove()
         try:
             self.add()
@@ -296,7 +193,7 @@
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
         self.entry_group_state_changed_match = (
             self.group.connect_to_signal(
-                'StateChanged', self.entry_group_state_changed))
+                'StateChanged', self .entry_group_state_changed))
         logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
@@ -328,7 +225,7 @@
             try:
                 self.group.Free()
             except (dbus.exceptions.UnknownMethodException,
-                    dbus.exceptions.DBusException):
+                    dbus.exceptions.DBusException) as e:
                 pass
             self.group = None
         self.remove()
@@ -368,17 +265,8 @@
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
-class AvahiServiceToSyslog(AvahiService):
-    def rename(self):
-        """Add the new name to the syslog messages"""
-        ret = AvahiService.rename(self)
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos (%s) [%%(process)d]:'
-                                ' %%(levelname)s: %%(message)s'
-                                % self.name))
-        return ret
 
-def timedelta_to_milliseconds(td):
+def _timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta() to milliseconds"
     return ((td.days * 24 * 60 * 60 * 1000)
             + (td.seconds * 1000)
@@ -388,7 +276,7 @@
     """A representation of a client host served by this server.
     
     Attributes:
-    approved:   bool(); 'None' if not yet approved/disapproved
+    _approved:   bool(); 'None' if not yet approved/disapproved
     approval_delay: datetime.timedelta(); Time to wait for approval
     approval_duration: datetime.timedelta(); Duration of one approval
     checker:    subprocess.Popen(); a running checker process used
@@ -401,9 +289,8 @@
                      instance %(name)s can be used in the command.
     checker_initiator_tag: a gobject event source tag, or None
     created:    datetime.datetime(); (UTC) object creation
-    client_structure: Object describing what attributes a client has
-                      and is used for storing the client at exit
     current_checker_command: string; current running checker_command
+    disable_hook:  If set, called by disable() as disable_hook(self)
     disable_initiator_tag: a gobject event source tag, or None
     enabled:    bool()
     fingerprint: string (40 or 32 hexadecimal digits); used to
@@ -412,10 +299,7 @@
     interval:   datetime.timedelta(); How often to start a new checker
     last_approval_request: datetime.datetime(); (UTC) or None
     last_checked_ok: datetime.datetime(); (UTC) or None
-    last_checker_status: integer between 0 and 255 reflecting exit
-                         status of last checker. -1 reflects crashed
-                         checker, or None.
-    last_enabled: datetime.datetime(); (UTC) or None
+    last_enabled: datetime.datetime(); (UTC)
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
     secret:     bytestring; sent verbatim (over TLS) to client
@@ -431,126 +315,81 @@
                           "created", "enabled", "fingerprint",
                           "host", "interval", "last_checked_ok",
                           "last_enabled", "name", "timeout")
-    client_defaults = { "timeout": "5m",
-                        "extended_timeout": "15m",
-                        "interval": "2m",
-                        "checker": "fping -q -- %%(host)s",
-                        "host": "",
-                        "approval_delay": "0s",
-                        "approval_duration": "1s",
-                        "approved_by_default": "True",
-                        "enabled": "True",
-                        }
     
     def timeout_milliseconds(self):
         "Return the 'timeout' attribute in milliseconds"
-        return timedelta_to_milliseconds(self.timeout)
+        return _timedelta_to_milliseconds(self.timeout)
     
     def extended_timeout_milliseconds(self):
         "Return the 'extended_timeout' attribute in milliseconds"
-        return timedelta_to_milliseconds(self.extended_timeout)
+        return _timedelta_to_milliseconds(self.extended_timeout)
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
-        return timedelta_to_milliseconds(self.interval)
+        return _timedelta_to_milliseconds(self.interval)
     
     def approval_delay_milliseconds(self):
-        return timedelta_to_milliseconds(self.approval_delay)
-
-    @staticmethod
-    def config_parser(config):
-        """ Construct a new dict of client settings of this form:
-        { client_name: {setting_name: value, ...}, ...}
-        with exceptions for any special settings as defined above"""
-        settings = {}
-        for client_name in config.sections():
-            section = dict(config.items(client_name))
-            client = settings[client_name] = {}
-            
-            client["host"] = section["host"]
-            # Reformat values from string types to Python types
-            client["approved_by_default"] = config.getboolean(
-                client_name, "approved_by_default")
-            client["enabled"] = config.getboolean(client_name, "enabled")
-            
-            client["fingerprint"] = (section["fingerprint"].upper()
-                                     .replace(" ", ""))
-            if "secret" in section:
-                client["secret"] = section["secret"].decode("base64")
-            elif "secfile" in section:
-                with open(os.path.expanduser(os.path.expandvars
-                                             (section["secfile"])),
-                          "rb") as secfile:
-                    client["secret"] = secfile.read()
-            else:
-                raise TypeError("No secret or secfile for section %s"
-                                % section)
-            client["timeout"] = string_to_delta(section["timeout"])
-            client["extended_timeout"] = string_to_delta(
-                section["extended_timeout"])
-            client["interval"] = string_to_delta(section["interval"])
-            client["approval_delay"] = string_to_delta(
-                section["approval_delay"])
-            client["approval_duration"] = string_to_delta(
-                section["approval_duration"])
-            client["checker_command"] = section["checker"]
-            client["last_approval_request"] = None
-            client["last_checked_ok"] = None
-            client["last_checker_status"] = None
-            if client["enabled"]:
-                client["last_enabled"] = datetime.datetime.utcnow()
-                client["expires"] = (datetime.datetime.utcnow()
-                                     + client["timeout"])
-            else:
-                client["last_enabled"] = None
-                client["expires"] = None
-
-        return settings
-        
-        
-    def __init__(self, settings, name = None):
+        return _timedelta_to_milliseconds(self.approval_delay)
+    
+    def __init__(self, name = None, disable_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
         self.name = name
-        # adding all client settings
-        for setting, value in settings.iteritems():
-            setattr(self, setting, value)
-        
+        if config is None:
+            config = {}
         logger.debug("Creating client %r", self.name)
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
         # function
+        self.fingerprint = (config["fingerprint"].upper()
+                            .replace(" ", ""))
         logger.debug("  Fingerprint: %s", self.fingerprint)
-        self.created = settings.get("created", datetime.datetime.utcnow())
-
-        # attributes specific for this server instance
+        if "secret" in config:
+            self.secret = config["secret"].decode("base64")
+        elif "secfile" in config:
+            with open(os.path.expanduser(os.path.expandvars
+                                         (config["secfile"])),
+                      "rb") as secfile:
+                self.secret = secfile.read()
+        else:
+            raise TypeError("No secret or secfile for client %s"
+                            % self.name)
+        self.host = config.get("host", "")
+        self.created = datetime.datetime.utcnow()
+        self.enabled = False
+        self.last_approval_request = None
+        self.last_enabled = None
+        self.last_checked_ok = None
+        self.timeout = string_to_delta(config["timeout"])
+        self.extended_timeout = string_to_delta(config
+                                                ["extended_timeout"])
+        self.interval = string_to_delta(config["interval"])
+        self.disable_hook = disable_hook
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
+        self.expires = None
         self.checker_callback_tag = None
+        self.checker_command = config["checker"]
         self.current_checker_command = None
-        self.approved = None
+        self.last_connect = None
+        self._approved = None
+        self.approved_by_default = config.get("approved_by_default",
+                                              True)
         self.approvals_pending = 0
+        self.approval_delay = string_to_delta(
+            config["approval_delay"])
+        self.approval_duration = string_to_delta(
+            config["approval_duration"])
         self.changedstate = (multiprocessing_manager
                              .Condition(multiprocessing_manager
                                         .Lock()))
-        self.client_structure = [attr for attr in
-                                 self.__dict__.iterkeys()
-                                 if not attr.startswith("_")]
-        self.client_structure.append("client_structure")
-        
-        for name, t in inspect.getmembers(type(self),
-                                          lambda obj:
-                                              isinstance(obj,
-                                                         property)):
-            if not name.startswith("_"):
-                self.client_structure.append(name)
     
-    # Send notice to process children that client state has changed
     def send_changedstate(self):
-        with self.changedstate:
-            self.changedstate.notify_all()
+        self.changedstate.acquire()
+        self.changedstate.notify_all()
+        self.changedstate.release()
     
     def enable(self):
         """Start this client's checker and timeout hooks"""
@@ -558,10 +397,20 @@
             # Already enabled
             return
         self.send_changedstate()
+        # Schedule a new checker to be started an 'interval' from now,
+        # and every interval from then on.
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (self.interval_milliseconds(),
+                                       self.start_checker))
+        # Schedule a disable() when 'timeout' has passed
         self.expires = datetime.datetime.utcnow() + self.timeout
+        self.disable_initiator_tag = (gobject.timeout_add
+                                   (self.timeout_milliseconds(),
+                                    self.disable))
         self.enabled = True
         self.last_enabled = datetime.datetime.utcnow()
-        self.init_checker()
+        # Also start a new checker *right now*.
+        self.start_checker()
     
     def disable(self, quiet=True):
         """Disable this client."""
@@ -579,33 +428,23 @@
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
+        if self.disable_hook:
+            self.disable_hook(self)
         self.enabled = False
         # Do not run this again if called by a gobject.timeout_add
         return False
     
     def __del__(self):
+        self.disable_hook = None
         self.disable()
     
-    def init_checker(self):
-        # Schedule a new checker to be started an 'interval' from now,
-        # and every interval from then on.
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (self.interval_milliseconds(),
-                                       self.start_checker))
-        # Schedule a disable() when 'timeout' has passed
-        self.disable_initiator_tag = (gobject.timeout_add
-                                   (self.timeout_milliseconds(),
-                                    self.disable))
-        # Also start a new checker *right now*.
-        self.start_checker()
-    
     def checker_callback(self, pid, condition, command):
         """The checker has completed, so take appropriate actions."""
         self.checker_callback_tag = None
         self.checker = None
         if os.WIFEXITED(condition):
-            self.last_checker_status = os.WEXITSTATUS(condition)
-            if self.last_checker_status == 0:
+            exitstatus = os.WEXITSTATUS(condition)
+            if exitstatus == 0:
                 logger.info("Checker for %(name)s succeeded",
                             vars(self))
                 self.checked_ok()
@@ -613,7 +452,6 @@
                 logger.info("Checker for %(name)s failed",
                             vars(self))
         else:
-            self.last_checker_status = -1
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
@@ -630,7 +468,7 @@
             gobject.source_remove(self.disable_initiator_tag)
         if getattr(self, "enabled", False):
             self.disable_initiator_tag = (gobject.timeout_add
-                                          (timedelta_to_milliseconds
+                                          (_timedelta_to_milliseconds
                                            (timeout), self.disable))
             self.expires = datetime.datetime.utcnow() + timeout
     
@@ -853,7 +691,7 @@
         
         Note: Will not include properties with access="write".
         """
-        properties = {}
+        all = {}
         for name, prop in self._get_all_dbus_properties():
             if (interface_name
                 and interface_name != prop._dbus_interface):
@@ -864,11 +702,11 @@
                 continue
             value = prop()
             if not hasattr(value, "variant_level"):
-                properties[name] = value
+                all[name] = value
                 continue
-            properties[name] = type(value)(value, variant_level=
-                                           value.variant_level+1)
-        return dbus.Dictionary(properties, signature="sv")
+            all[name] = type(value)(value, variant_level=
+                                    value.variant_level+1)
+        return dbus.Dictionary(all, signature="sv")
     
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
                          out_signature="s",
@@ -925,7 +763,6 @@
     return dbus.String(dt.isoformat(),
                        variant_level=variant_level)
 
-
 class AlternateDBusNamesMetaclass(DBusObjectWithProperties
                                   .__metaclass__):
     """Applied to an empty subclass of a D-Bus object, this metaclass
@@ -1023,7 +860,6 @@
                                         attribute.func_closure)))
         return type.__new__(mcs, name, bases, attr)
 
-
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
@@ -1038,11 +874,9 @@
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
+        self._approvals_pending = 0
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
-        self._approvals_pending = 0
-        
-        self._approvals_pending = 0
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
@@ -1058,7 +892,7 @@
                              variant_level=1):
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
-        
+
         transform_fun: Function that takes a value and a variant_level
                        and transforms it to a D-Bus type.
         dbus_name: D-Bus name of the variable
@@ -1098,24 +932,24 @@
         datetime_to_dbus, "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
                                                "ApprovedByDefault")
-    approval_delay = notifychangeproperty(dbus.UInt64,
+    approval_delay = notifychangeproperty(dbus.UInt16,
                                           "ApprovalDelay",
                                           type_func =
-                                          timedelta_to_milliseconds)
+                                          _timedelta_to_milliseconds)
     approval_duration = notifychangeproperty(
-        dbus.UInt64, "ApprovalDuration",
-        type_func = timedelta_to_milliseconds)
+        dbus.UInt16, "ApprovalDuration",
+        type_func = _timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
-    timeout = notifychangeproperty(dbus.UInt64, "Timeout",
+    timeout = notifychangeproperty(dbus.UInt16, "Timeout",
                                    type_func =
-                                   timedelta_to_milliseconds)
+                                   _timedelta_to_milliseconds)
     extended_timeout = notifychangeproperty(
-        dbus.UInt64, "ExtendedTimeout",
-        type_func = timedelta_to_milliseconds)
-    interval = notifychangeproperty(dbus.UInt64,
+        dbus.UInt16, "ExtendedTimeout",
+        type_func = _timedelta_to_milliseconds)
+    interval = notifychangeproperty(dbus.UInt16,
                                     "Interval",
                                     type_func =
-                                    timedelta_to_milliseconds)
+                                    _timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
     
     del notifychangeproperty
@@ -1163,13 +997,13 @@
         return r
     
     def _reset_approved(self):
-        self.approved = None
+        self._approved = None
         return False
     
     def approve(self, value=True):
         self.send_changedstate()
-        self.approved = value
-        gobject.timeout_add(timedelta_to_milliseconds
+        self._approved = value
+        gobject.timeout_add(_timedelta_to_milliseconds
                             (self.approval_duration),
                             self._reset_approved)
     
@@ -1218,14 +1052,6 @@
         "D-Bus signal"
         return self.need_approval()
     
-    # NeRwequest - signal
-    @dbus.service.signal(_interface, signature="s")
-    def NewRequest(self, ip):
-        """D-Bus signal
-        Is sent after a client request a password.
-        """
-        pass
-    
     ## Methods
     
     # Approve - method
@@ -1289,7 +1115,7 @@
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(timedelta_to_milliseconds(
+            return dbus.UInt64(_timedelta_to_milliseconds(
                     self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
     
@@ -1309,12 +1135,12 @@
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
-        self.host = unicode(value)
+        self.host = value
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
     def Created_dbus_property(self):
-        return datetime_to_dbus(self.created)
+        return dbus.String(datetime_to_dbus(self.created))
     
     # LastEnabled - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1364,11 +1190,11 @@
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
         self.expires = None
-        time_to_die = timedelta_to_milliseconds((self
-                                                 .last_checked_ok
-                                                 + self.timeout)
-                                                - datetime.datetime
-                                                .utcnow())
+        time_to_die = _timedelta_to_milliseconds((self
+                                                  .last_checked_ok
+                                                  + self.timeout)
+                                                 - datetime.datetime
+                                                 .utcnow())
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()
@@ -1396,12 +1222,11 @@
         self.interval = datetime.timedelta(0, 0, 0, value)
         if getattr(self, "checker_initiator_tag", None) is None:
             return
-        if self.enabled:
-            # Reschedule checker run
-            gobject.source_remove(self.checker_initiator_tag)
-            self.checker_initiator_tag = (gobject.timeout_add
-                                          (value, self.start_checker))
-            self.start_checker()    # Start one now, too
+        # Reschedule checker run
+        gobject.source_remove(self.checker_initiator_tag)
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (value, self.start_checker))
+        self.start_checker()    # Start one now, too
     
     # Checker - property
     @dbus_service_property(_interface, signature="s",
@@ -1409,7 +1234,7 @@
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
-        self.checker_command = unicode(value)
+        self.checker_command = value
     
     # CheckerRunning - property
     @dbus_service_property(_interface, signature="b",
@@ -1444,7 +1269,7 @@
             raise KeyError()
     
     def __getattribute__(self, name):
-        if name == '_pipe':
+        if(name == '_pipe'):
             return super(ProxyClient, self).__getattribute__(name)
         self._pipe.send(('getattr', name))
         data = self._pipe.recv()
@@ -1457,15 +1282,13 @@
             return func
     
     def __setattr__(self, name, value):
-        if name == '_pipe':
+        if(name == '_pipe'):
             return super(ProxyClient, self).__setattr__(name, value)
         self._pipe.send(('setattr', name, value))
 
-
 class ClientDBusTransitional(ClientDBus):
     __metaclass__ = AlternateDBusNamesMetaclass
 
-
 class ClientHandler(socketserver.BaseRequestHandler, object):
     """A class to handle client connections.
     
@@ -1539,10 +1362,6 @@
                 except KeyError:
                     return
                 
-                if self.server.use_dbus:
-                    # Emit D-Bus signal
-                    client.NewRequest(str(self.client_address))
-                
                 if client.approval_delay:
                     delay = client.approval_delay
                     client.approvals_pending += 1
@@ -1557,10 +1376,10 @@
                             client.Rejected("Disabled")
                         return
                     
-                    if client.approved or not client.approval_delay:
+                    if client._approved or not client.approval_delay:
                         #We are approved or approval is disabled
                         break
-                    elif client.approved is None:
+                    elif client._approved is None:
                         logger.info("Client %s needs approval",
                                     client.name)
                         if self.server.use_dbus:
@@ -1580,7 +1399,7 @@
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
                     (client.changedstate.wait
-                     (float(client.timedelta_to_milliseconds(delay)
+                     (float(client._timedelta_to_milliseconds(delay)
                             / 1000)))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
@@ -1685,7 +1504,7 @@
         # Convert the buffer to a Python bytestring
         fpr = ctypes.string_at(buf, buf_len.value)
         # Convert the bytestring to hexadecimal notation
-        hex_fpr = binascii.hexlify(fpr).upper()
+        hex_fpr = ''.join("%02X" % ord(char) for char in fpr)
         return hex_fpr
 
 
@@ -1694,7 +1513,7 @@
     def sub_process_main(self, request, address):
         try:
             self.finish_request(request, address)
-        except Exception:
+        except:
             self.handle_error(request, address)
         self.close_request(request)
     
@@ -1805,7 +1624,7 @@
         self.enabled = False
         self.clients = clients
         if self.clients is None:
-            self.clients = {}
+            self.clients = set()
         self.use_dbus = use_dbus
         self.gnutls_priority = gnutls_priority
         IPv6_TCPServer.__init__(self, server_address,
@@ -1858,7 +1677,7 @@
             fpr = request[1]
             address = request[2]
             
-            for c in self.clients.itervalues():
+            for c in self.clients:
                 if c.fingerprint == fpr:
                     client = c
                     break
@@ -1948,6 +1767,30 @@
     return timevalue
 
 
+def if_nametoindex(interface):
+    """Call the C function if_nametoindex(), or equivalent
+    
+    Note: This function cannot accept a unicode string."""
+    global if_nametoindex
+    try:
+        if_nametoindex = (ctypes.cdll.LoadLibrary
+                          (ctypes.util.find_library("c"))
+                          .if_nametoindex)
+    except (OSError, AttributeError):
+        logger.warning("Doing if_nametoindex the hard way")
+        def if_nametoindex(interface):
+            "Get an interface index the hard way, i.e. using fcntl()"
+            SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
+            with contextlib.closing(socket.socket()) as s:
+                ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
+                                    struct.pack(str("16s16x"),
+                                                interface))
+            interface_index = struct.unpack(str("I"),
+                                            ifreq[16:20])[0]
+            return interface_index
+    return if_nametoindex(interface)
+
+
 def daemon(nochdir = False, noclose = False):
     """See daemon(3).  Standard BSD Unix function.
     
@@ -2008,12 +1851,6 @@
                         " system bus interface")
     parser.add_argument("--no-ipv6", action="store_false",
                         dest="use_ipv6", help="Do not use IPv6")
-    parser.add_argument("--no-restore", action="store_false",
-                        dest="restore", help="Do not restore stored"
-                        " state")
-    parser.add_argument("--statedir", metavar="DIR",
-                        help="Directory to save/restore state in")
-    
     options = parser.parse_args()
     
     if options.check:
@@ -2032,8 +1869,6 @@
                         "use_dbus": "True",
                         "use_ipv6": "True",
                         "debuglevel": "",
-                        "restore": "True",
-                        "statedir": "/var/lib/mandos"
                         }
     
     # Parse config file for server-global settings
@@ -2056,8 +1891,7 @@
     # options, if set.
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir"):
+                   "use_dbus", "use_ipv6", "debuglevel"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2075,17 +1909,6 @@
     debuglevel = server_settings["debuglevel"]
     use_dbus = server_settings["use_dbus"]
     use_ipv6 = server_settings["use_ipv6"]
-    stored_state_path = os.path.join(server_settings["statedir"],
-                                     stored_state_file)
-    
-    if debug:
-        initlogger(debug, logging.DEBUG)
-    else:
-        if not debuglevel:
-            initlogger(debug)
-        else:
-            level = getattr(logging, debuglevel.upper())
-            initlogger(debug, level)
     
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
@@ -2094,7 +1917,15 @@
                                 % server_settings["servicename"]))
     
     # Parse config file with clients
-    client_config = configparser.SafeConfigParser(Client.client_defaults)
+    client_defaults = { "timeout": "5m",
+                        "extended_timeout": "15m",
+                        "interval": "2m",
+                        "checker": "fping -q -- %%(host)s",
+                        "host": "",
+                        "approval_delay": "0s",
+                        "approval_duration": "1s",
+                        }
+    client_config = configparser.SafeConfigParser(client_defaults)
     client_config.read(os.path.join(server_settings["configdir"],
                                     "clients.conf"))
     
@@ -2138,6 +1969,14 @@
         if error[0] != errno.EPERM:
             raise error
     
+    if not debug and not debuglevel:
+        syslogger.setLevel(logging.WARNING)
+        console.setLevel(logging.WARNING)
+    if debuglevel:
+        level = getattr(logging, debuglevel.upper())
+        syslogger.setLevel(level)
+        console.setLevel(level)
+    
     if debug:
         # Enable all possible GnuTLS debugging
         
@@ -2157,14 +1996,15 @@
         os.dup2(null, sys.stdin.fileno())
         if null > 2:
             os.close(null)
+    else:
+        # No console logging
+        logger.removeHandler(console)
     
     # Need to fork before connecting to D-Bus
     if not debug:
         # Close all input and output, do double fork, etc.
         daemon()
     
-    gobject.threads_init()
-    
     global main_loop
     # From the Avahi example code
     DBusGMainLoop(set_as_default=True )
@@ -2184,10 +2024,9 @@
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
     protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-    service = AvahiServiceToSyslog(name =
-                                   server_settings["servicename"],
-                                   servicetype = "_mandos._tcp",
-                                   protocol = protocol, bus = bus)
+    service = AvahiService(name = server_settings["servicename"],
+                           servicetype = "_mandos._tcp",
+                           protocol = protocol, bus = bus)
     if server_settings["interface"]:
         service.interface = (if_nametoindex
                              (str(server_settings["interface"])))
@@ -2199,94 +2038,23 @@
     if use_dbus:
         client_class = functools.partial(ClientDBusTransitional,
                                          bus = bus)
-    
-    client_settings = Client.config_parser(client_config)
-    old_client_settings = {}
-    clients_data = {}
-    
-    # Get client data and settings from last running state.
-    if server_settings["restore"]:
-        try:
-            with open(stored_state_path, "rb") as stored_state:
-                clients_data, old_client_settings = (pickle.load
-                                                     (stored_state))
-            os.remove(stored_state_path)
-        except IOError as e:
-            logger.warning("Could not load persistent state: {0}"
-                           .format(e))
-            if e.errno != errno.ENOENT:
-                raise
-        except EOFError as e:
-            logger.warning("Could not load persistent state: "
-                           "EOFError: {0}".format(e))
-    
-    with PGPEngine() as pgp:
-        for client_name, client in clients_data.iteritems():
-            # Decide which value to use after restoring saved state.
-            # We have three different values: Old config file,
-            # new config file, and saved state.
-            # New config value takes precedence if it differs from old
-            # config value, otherwise use saved state.
-            for name, value in client_settings[client_name].items():
-                try:
-                    # For each value in new config, check if it
-                    # differs from the old config value (Except for
-                    # the "secret" attribute)
-                    if (name != "secret" and
-                        value != old_client_settings[client_name]
-                        [name]):
-                        client[name] = value
-                except KeyError:
-                    pass
-            
-            # Clients who has passed its expire date can still be
-            # enabled if its last checker was successful.  Clients
-            # whose checker failed before we stored its state is
-            # assumed to have failed all checkers during downtime.
-            if client["enabled"]:
-                if datetime.datetime.utcnow() >= client["expires"]:
-                    if not client["last_checked_ok"]:
-                        logger.warning(
-                            "disabling client {0} - Client never "
-                            "performed a successfull checker"
-                            .format(client["name"]))
-                        client["enabled"] = False
-                    elif client["last_checker_status"] != 0:
-                        logger.warning(
-                            "disabling client {0} - Client "
-                            "last checker failed with error code {1}"
-                            .format(client["name"],
-                                    client["last_checker_status"]))
-                        client["enabled"] = False
-                    else:
-                        client["expires"] = (datetime.datetime
-                                             .utcnow()
-                                             + client["timeout"])
-                    
+    def client_config_items(config, section):
+        special_settings = {
+            "approved_by_default":
+                lambda: config.getboolean(section,
+                                          "approved_by_default"),
+            }
+        for name, value in config.items(section):
             try:
-                client["secret"] = (
-                    pgp.decrypt(client["encrypted_secret"],
-                                client_settings[client_name]
-                                ["secret"]))
-            except PGPError:
-                # If decryption fails, we use secret from new settings
-                logger.debug("Failed to decrypt {0} old secret"
-                             .format(client_name))
-                client["secret"] = (
-                    client_settings[client_name]["secret"])
-
-    
-    # Add/remove clients based on new changes made to config
-    for client_name in set(old_client_settings) - set(client_settings):
-        del clients_data[client_name]
-    for client_name in set(client_settings) - set(old_client_settings):
-        clients_data[client_name] = client_settings[client_name]
-
-    # Create clients all clients
-    for client_name, client in clients_data.iteritems():
-        tcp_server.clients[client_name] = client_class(
-            name = client_name, settings = client)
-    
+                yield (name, special_settings[name]())
+            except KeyError:
+                yield (name, value)
+    
+    tcp_server.clients.update(set(
+            client_class(name = section,
+                         config= dict(client_config_items(
+                        client_config, section)))
+            for section in client_config.sections()))
     if not tcp_server.clients:
         logger.warning("No clients defined")
         
@@ -2303,6 +2071,7 @@
             # "pidfile" was never created
             pass
         del pidfilename
+        
         signal.signal(signal.SIGINT, signal.SIG_IGN)
     
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
@@ -2334,8 +2103,7 @@
             def GetAllClients(self):
                 "D-Bus method"
                 return dbus.Array(c.dbus_object_path
-                                  for c in
-                                  tcp_server.clients.itervalues())
+                                  for c in tcp_server.clients)
             
             @dbus.service.method(_interface,
                                  out_signature="a{oa{sv}}")
@@ -2343,15 +2111,15 @@
                 "D-Bus method"
                 return dbus.Dictionary(
                     ((c.dbus_object_path, c.GetAll(""))
-                     for c in tcp_server.clients.itervalues()),
+                     for c in tcp_server.clients),
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
                 "D-Bus method"
-                for c in tcp_server.clients.itervalues():
+                for c in tcp_server.clients:
                     if c.dbus_object_path == object_path:
-                        del tcp_server.clients[c.name]
+                        tcp_server.clients.remove(c)
                         c.remove_from_connection()
                         # Don't signal anything except ClientRemoved
                         c.disable(quiet=True)
@@ -2371,62 +2139,11 @@
         service.cleanup()
         
         multiprocessing.active_children()
-        if not (tcp_server.clients or client_settings):
-            return
-        
-        # Store client before exiting. Secrets are encrypted with key
-        # based on what config file has. If config file is
-        # removed/edited, old secret will thus be unrecovable.
-        clients = {}
-        with PGPEngine() as pgp:
-            for client in tcp_server.clients.itervalues():
-                key = client_settings[client.name]["secret"]
-                client.encrypted_secret = pgp.encrypt(client.secret,
-                                                      key)
-                client_dict = {}
-                
-                # A list of attributes that can not be pickled
-                # + secret.
-                exclude = set(("bus", "changedstate", "secret",
-                               "checker"))
-                for name, typ in (inspect.getmembers
-                                  (dbus.service.Object)):
-                    exclude.add(name)
-                
-                client_dict["encrypted_secret"] = (client
-                                                   .encrypted_secret)
-                for attr in client.client_structure:
-                    if attr not in exclude:
-                        client_dict[attr] = getattr(client, attr)
-                
-                clients[client.name] = client_dict
-                del client_settings[client.name]["secret"]
-        
-        try:
-            tempfd, tempname = tempfile.mkstemp(suffix=".pickle",
-                                                prefix="clients-",
-                                                dir=os.path.dirname
-                                                (stored_state_path))
-            with os.fdopen(tempfd, "wb") as stored_state:
-                pickle.dump((clients, client_settings), stored_state)
-            os.rename(tempname, stored_state_path)
-        except (IOError, OSError) as e:
-            logger.warning("Could not save persistent state: {0}"
-                           .format(e))
-            if not debug:
-                try:
-                    os.remove(tempname)
-                except NameError:
-                    pass
-            if e.errno not in set((errno.ENOENT, errno.EACCES,
-                                   errno.EEXIST)):
-                raise e
-        
-        # Delete all clients, and settings from config
         while tcp_server.clients:
-            name, client = tcp_server.clients.popitem()
+            client = tcp_server.clients.pop()
             if use_dbus:
                 client.remove_from_connection()
+            client.disable_hook = None
             # Don't signal anything except ClientRemoved
             client.disable(quiet=True)
             if use_dbus:
@@ -2434,17 +2151,14 @@
                 mandos_dbus_service.ClientRemoved(client
                                                   .dbus_object_path,
                                                   client.name)
-        client_settings.clear()
     
     atexit.register(cleanup)
     
-    for client in tcp_server.clients.itervalues():
+    for client in tcp_server.clients:
         if use_dbus:
             # Emit D-Bus signal
             mandos_dbus_service.ClientAdded(client.dbus_object_path)
-        # Need to initiate checking of clients
-        if client.enabled:
-            client.init_checker()
+        client.enable()
     
     tcp_server.enable()
     tcp_server.server_activate()
@@ -2490,5 +2204,6 @@
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 
+
 if __name__ == '__main__':
     main()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2011-11-26 23:08:17 +0000
+++ mandos-clients.conf.xml	2011-10-10 20:29:58 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2011-11-26">
+<!ENTITY TIMESTAMP "2011-10-10">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -344,20 +344,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>enabled<literal> = </literal>{ <literal
-	>1</literal> | <literal>yes</literal> |	<literal>true</literal
-	> | <literal >on</literal> | <literal>0</literal> | <literal
-	>no</literal> | <literal>false</literal> | <literal
-	>off</literal> }</option></term>
-	<listitem>
-	  <para>
-	    Whether this client should be enabled by default.  The
-	    default is <quote>true</quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'mandos-ctl'
--- mandos-ctl	2011-12-21 17:17:32 +0000
+++ mandos-ctl	2011-10-15 16:48:03 +0000
@@ -93,23 +93,29 @@
     >>> string_to_delta("5m 30s")
     datetime.timedelta(0, 330)
     """
-    value = datetime.timedelta(0)
-    regexp = re.compile("(\d+)([dsmhw]?)")
+    timevalue = datetime.timedelta(0)
+    regexp = re.compile("\d+[dsmhw]")
     
-    for num, suffix in regexp.findall(interval):
-        if suffix == "d":
-            value += datetime.timedelta(int(num))
-        elif suffix == "s":
-            value += datetime.timedelta(0, int(num))
-        elif suffix == "m":
-            value += datetime.timedelta(0, 0, 0, 0, int(num))
-        elif suffix == "h":
-            value += datetime.timedelta(0, 0, 0, 0, 0, int(num))
-        elif suffix == "w":
-            value += datetime.timedelta(0, 0, 0, 0, 0, 0, int(num))
-        elif suffix == "":
-            value += datetime.timedelta(0, 0, 0, int(num))
-    return value
+    for s in regexp.findall(interval):
+        try:
+            suffix = unicode(s[-1])
+            value = int(s[:-1])
+            if suffix == "d":
+                delta = datetime.timedelta(value)
+            elif suffix == "s":
+                delta = datetime.timedelta(0, value)
+            elif suffix == "m":
+                delta = datetime.timedelta(0, 0, 0, 0, value)
+            elif suffix == "h":
+                delta = datetime.timedelta(0, 0, 0, 0, 0, value)
+            elif suffix == "w":
+                delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
+            else:
+                raise ValueError
+        except (ValueError, IndexError):
+            raise ValueError
+        timevalue += delta
+    return timevalue
 
 def print_clients(clients, keywords):
     def valuetostring(value, keyword):
@@ -236,7 +242,7 @@
             #restore stderr
             os.dup2(stderrcopy, sys.stderr.fileno())
             os.close(stderrcopy)
-    except dbus.exceptions.DBusException:
+    except dbus.exceptions.DBusException, e:
         print("Access denied: Accessing mandos server through dbus.",
               file=sys.stderr)
         sys.exit(1)

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2011-11-12 18:14:55 +0000
+++ mandos-keygen.xml	2011-10-05 16:00:56 +0000
@@ -214,7 +214,7 @@
 	<listitem>
 	  <para>
 	    Target directory for key files.  Default is
-	    <filename class="directory">/etc/mandos</filename>.
+	    <filename>/etc/mandos</filename>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -411,7 +411,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename class="directory">/tmp</filename></term>
+	<term><filename>/tmp</filename></term>
 	<listitem>
 	  <para>
 	    Temporary files will be written here if
@@ -452,9 +452,9 @@
     </informalexample>
     <informalexample>
       <para>
-	Prompt for a password, encrypt it with the key in <filename
-	class="directory">/etc/mandos</filename> and output a section
-	suitable for <filename>clients.conf</filename>.
+	Prompt for a password, encrypt it with the key in
+	<filename>/etc/mandos</filename> and output a section suitable
+	for <filename>clients.conf</filename>.
       </para>
       <para>
 	<userinput>&COMMANDNAME; --password</userinput>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2011-11-26 22:22:20 +0000
+++ mandos-options.xml	2009-02-13 05:38:21 +0000
@@ -86,15 +86,4 @@
     advanced users should consider changing this option</emphasis>.
   </para>
   
-  <para id="restore">
-    This option controls whether the server will restore any state from
-    last time it ran. Default is to try restore last state.
-  </para>
-  
-  <para id="statedir">
-    Directory to save (and restore) state in.  Default is
-    <quote><filename
-    class="directory">/var/lib/mandos</filename></quote>.
-  </para>
-  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2011-11-26 22:22:20 +0000
+++ mandos.conf	2009-02-13 05:38:21 +0000
@@ -4,27 +4,33 @@
 # These are the default values for the server, uncomment and change
 # them if needed.
 
+
 # If "interface" is set, the server will only listen to a specific
 # network interface.
 ;interface = 
 
+
 # If "address" is set, the server will only listen to a specific
 # address.  This must currently be an IPv6 address; an IPv4 address
 # can be specified using the "::FFFF:192.0.2.3" syntax.  Also, if this
 # is a link-local address, an interface should be set above.
 ;address =
 
+
 # If "port" is set, the server to bind to that port. By default, the
 # server will listen to an arbitrary port.
 ;port = 
 
+
 # If "debug" is true, the server will run in the foreground and print
 # a lot of debugging information.
 ;debug = False
 
+
 # GnuTLS priority for the TLS handshake.  See gnutls_priority_init(3).
 ;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
 
+
 # Zeroconf service name.  You need to change this if you for some
 # reason want to run more than one server on the same *host*.
 # If there are name collisions on the same *network*, the server will
@@ -36,9 +42,3 @@
 
 # Whether to use IPv6.  (Changing this is NOT recommended.)
 ;use_ipv6 = True
-
-# Whether to restore saved state on startup
-;restore = True
-
-# The directory where state is saved
-;statedir = /var/lib/mandos

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2011-11-26 22:22:20 +0000
+++ mandos.conf.xml	2011-10-05 16:00:56 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2011-11-26">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -154,25 +154,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>restore<literal> = </literal>{ <literal
-	  >1</literal> | <literal>yes</literal> | <literal
-	  >true</literal> | <literal>on</literal> | <literal
-	  >0</literal> | <literal>no</literal> | <literal
-	  >false</literal> | <literal>off</literal> }</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="restore"/>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>statedir<literal> = </literal><replaceable
-	>DIRECTORY</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   
@@ -217,8 +198,6 @@
 servicename = Daena
 use_dbus = False
 use_ipv6 = True
-restore = True
-statedir = /var/lib/mandos
       </programlisting>
     </informalexample>
   </refsect1>

=== modified file 'mandos.xml'
--- mandos.xml	2011-12-21 00:29:33 +0000
+++ mandos.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2011-11-26">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -94,11 +94,6 @@
       <arg><option>--no-dbus</option></arg>
       <sbr/>
       <arg><option>--no-ipv6</option></arg>
-      <sbr/>
-      <arg><option>--no-restore</option></arg>
-      <sbr/>
-      <arg><option>--statedir
-      <replaceable>DIRECTORY</replaceable></option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -280,21 +275,6 @@
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
 	</listitem>
       </varlistentry>
-      
-      <varlistentry>
-	<term><option>--no-restore</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="restore"/>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--statedir
-	<replaceable>DIRECTORY</replaceable></option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -407,7 +387,7 @@
     <title>LOGGING</title>
     <para>
       The server will send log message with various severity levels to
-      <filename class="devicefile">/dev/log</filename>.  With the
+      <filename>/dev/log</filename>.  With the
       <option>--debug</option> option, it will log even more messages,
       and also show them on the console.
     </para>
@@ -489,20 +469,6 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename class="devicefile">/dev/log</filename></term>
-      </varlistentry>
-      <varlistentry>
-	<term><filename
-	class="directory">/var/lib/mandos</filename></term>
-	<listitem>
-	  <para>
-	    Directory where persistent state will be saved.  Change
-	    this with the <option>--statedir</option> option.  See
-	    also the <option>--no-restore</option> option.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
 	<term><filename>/dev/log</filename></term>
 	<listitem>
 	  <para>
@@ -532,12 +498,20 @@
       backtrace.  This could be considered a feature.
     </para>
     <para>
+      Currently, if a client is disabled due to having timed out, the
+      server does not record this fact onto permanent storage.  This
+      has some security implications, see <xref linkend="clients"/>.
+    </para>
+    <para>
       There is no fine-grained control over logging and debug output.
     </para>
     <para>
       Debug mode is conflated with running in the foreground.
     </para>
     <para>
+      The console log messages do not show a time stamp.
+    </para>
+    <para>
       This server does not check the expire time of clients’ OpenPGP
       keys.
     </para>
@@ -556,9 +530,9 @@
     <informalexample>
       <para>
 	Run the server in debug mode, read configuration files from
-	the <filename class="directory">~/mandos</filename> directory,
-	and use the Zeroconf service name <quote>Test</quote> to not
-	collide with any other official Mandos server on this host:
+	the <filename>~/mandos</filename> directory, and use the
+	Zeroconf service name <quote>Test</quote> to not collide with
+	any other official Mandos server on this host:
       </para>
       <para>
 
@@ -613,6 +587,21 @@
 	compromised if they are gone for too long.
       </para>
       <para>
+	If a client is compromised, its downtime should be duly noted
+	by the server which would therefore disable the client.  But
+	if the server was ever restarted, it would re-read its client
+	list from its configuration file and again regard all clients
+	therein as enabled, and hence eligible to receive their
+	passwords.  Therefore, be careful when restarting servers if
+	it is suspected that a client has, in fact, been compromised
+	by parties who may now be running a fake Mandos client with
+	the keys from the non-encrypted initial <acronym>RAM</acronym>
+	image of the client host.  What should be done in that case
+	(if restarting the server program really is necessary) is to
+	stop the server program, edit the configuration file to omit
+	any suspect clients, and restart the server program.
+      </para>
+      <para>
 	For more details on client-side security, see
 	<citerefentry><refentrytitle>mandos-client</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry>.

=== modified file 'network-hooks.d/bridge'
--- network-hooks.d/bridge	2011-12-31 13:25:58 +0000
+++ network-hooks.d/bridge	2011-11-28 00:27:49 +0000
@@ -15,17 +15,13 @@
 
 CONFIG="$MANDOSNETHOOKDIR/bridge.conf"
 
-addrtoif(){
-    grep -liFe "$1" /sys/class/net/*/address | sed -e 's,.*/\([^/]*\)/[^/]*,\1,'
-}
-
-# Read config file, which must set "BRIDGE", "PORT_ADDRESSES", and
-# optionally "IPADDRS" and "ROUTES".
+# Read config file, which must set "BRIDGE", "PORTS", and optionally
+# "IPADDRS" and "ROUTES".
 if [ -e "$CONFIG" ]; then
     . "$CONFIG"
 fi
 
-if [ -z "$BRIDGE" -o -z "$PORT_ADDRESSES" ]; then
+if [ -z "$BRIDGE" -o -z "$PORTS" ]; then
     exit
 fi
 
@@ -33,23 +29,13 @@
     exit
 fi
 
-for b in /sbin/brctl /usr/sbin/brctl; do
-    if [ -e "$b" ]; then
-	brctl="$b"
-	break
-    fi
-done
-
 case "$1" in
     start)
-	"$brctl" addbr "$BRIDGE"
-	for address in $PORT_ADDRESSES; do
-	    interface=`addrtoif "$address"`
-	    "$brctl" addif "$BRIDGE" "$interface"
-	    ip link set dev "$interface" up
+	/usr/sbin/brctl addbr "$BRIDGE"
+	for port in $PORTS; do
+	    /usr/sbin/brctl addif "$BRIDGE" "$port"
 	done
-	ip link set dev "$BRIDGE" up
-	sleep "$DELAY"
+	ip link set up "$BRIDGE"
 	if [ -n "$IPADDRS" ]; then
             for ipaddr in $IPADDRS; do
 		ip addr add "$ipaddr" dev "$BRIDGE"
@@ -62,17 +48,15 @@
 	fi
 	;;
     stop)
-	ip link set dev "$BRIDGE" down
-	for address in $PORT_ADDRESSES; do
-	    interface=`addrtoif "$address"`
-	    ip link set dev "$interface" down
-	    "$brctl" delif "$BRIDGE" "$interface"
+	ip link set down "$BRIDGE"
+	for port in $PORTS; do
+	    /usr/sbin/brctl delif "$BRIDGE" "$port"
 	done
-	"$brctl" delbr "$BRIDGE"
+	/usr/sbin/brctl delbr "$BRIDGE"
 	;;
     files)
 	echo /bin/ip
-	echo "$brctl"
+	echo /usr/sbin/brctl
 	;;
     modules)
 	echo bridge

=== modified file 'network-hooks.d/bridge.conf'
--- network-hooks.d/bridge.conf	2011-12-31 13:25:58 +0000
+++ network-hooks.d/bridge.conf	2011-11-24 20:15:24 +0000
@@ -2,7 +2,7 @@
 
 #BRIDGE=br0
 
-#PORT_ADDRESSES="00:11:22:33:44:55 11:22:33:44:55:66"
+#PORTS="eth0 eth1"
 
 ## Optional
 

=== removed file 'network-hooks.d/openvpn'
--- network-hooks.d/openvpn	2011-12-02 16:52:50 +0000
+++ network-hooks.d/openvpn	1970-01-01 00:00:00 +0000
@@ -1,52 +0,0 @@
-#!/bin/sh
-#
-# This is an example of a Mandos client network hook.  This hook
-# brings up an OpenVPN interface as specified in a separate
-# configuration file.  To be used, this file and any needed
-# configuration file(s) should be copied into the
-# /etc/mandos/network-hooks.d directory.
-# 
-# Copying and distribution of this file, with or without modification,
-# are permitted in any medium without royalty provided the copyright
-# notice and this notice are preserved.  This file is offered as-is,
-# without any warranty.
-
-set -e
-
-CONFIG="openvpn.conf"
-
-# Extract the "dev" setting from the config file
-VPNDEVICE="`sed -n -e 's/#.*//' -e 's/^[[:space:]]*dev[[:space:]]\+//p' \"$MANDOSNETHOOKDIR/$CONFIG\"`"
-
-PIDFILE=/run/openvpn-mandos.pid
-
-# Exit if no device set in config
-if [ -z "$VPNDEVICE" ]; then
-    exit
-fi
-
-# Exit if DEVICE is set and it doesn't match the VPN interface
-if [ -n "$DEVICE" -a "$DEVICE" = "${DEVICE#$VPNDEVICE}" ]; then
-    exit
-fi
-
-openvpn=/usr/sbin/openvpn
-
-case "$1" in
-    start)
-	"$openvpn" --cd "$MANDOSNETHOOKDIR" --daemon 'openvpn(Mandos)' --writepid "$PIDFILE" --config "$CONFIG"
-	sleep "$DELAY"
-	;;
-    stop)
-	PID="`cat \"$PIDFILE\"`"
-	if [ "$PID" -gt 0 ]; then
-	    kill "$PID"
-	fi
-	;;
-    files)
-	echo "$openvpn"
-	;;
-    modules)
-	echo tun
-	;;
-esac

=== removed file 'network-hooks.d/openvpn.conf'
--- network-hooks.d/openvpn.conf	2011-12-02 16:52:50 +0000
+++ network-hooks.d/openvpn.conf	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-# Sample OpenVPN configuration file
-# Uncomment and change - see openvpn(8)
-
-# Network device.
-#dev tun
-
-# Our remote peer
-#remote 192.0.2.3
-#float 192.0.2.3
-#port 1194
-
-# VPN endpoints
-#ifconfig 10.1.0.1 10.1.0.2
-
-# A pre-shared static key
-#secret openvpn.key
-
-# Cipher
-#cipher AES-128-CBC

=== removed file 'network-hooks.d/wireless'
--- network-hooks.d/wireless	2011-12-31 13:25:58 +0000
+++ network-hooks.d/wireless	1970-01-01 00:00:00 +0000
@@ -1,153 +0,0 @@
-#!/bin/sh
-#
-# This is an example of a Mandos client network hook.  This hook
-# brings up a wireless interface as specified in a separate
-# configuration file.  To be used, this file and any needed
-# configuration file(s) should be copied into the
-# /etc/mandos/network-hooks.d directory.
-# 
-# Copying and distribution of this file, with or without modification,
-# are permitted in any medium without royalty provided the copyright
-# notice and this notice are preserved.  This file is offered as-is,
-# without any warranty.
-
-set -e
-
-RUNDIR="/run"
-CTRL="$RUNDIR/wpa_supplicant-global"
-CTRLDIR="$RUNDIR/wpa_supplicant"
-PIDFILE="$RUNDIR/wpa_supplicant-mandos.pid"
-
-CONFIG="$MANDOSNETHOOKDIR/wireless.conf"
-
-addrtoif(){
-    grep -liFe "$1" /sys/class/net/*/address | sed -e 's,.*/\([^/]*\)/[^/]*,\1,'
-}
-
-# Read config file
-if [ -e "$CONFIG" ]; then
-    . "$CONFIG"
-else
-    exit
-fi
-
-ifkeys="`env | sed -n -e 's/^ADDRESS_\([^=]*\)=.*/\1/p' \"$CONFIG\" | sort -u`"
-
-# Exit if DEVICE is set and is not any of the wireless interfaces
-if [ -n "$DEVICE" ]; then
-    while :; do
-	for KEY in $ifkeys; do
-	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
-	    INTERFACE=`addrtoif "$ADDRESS"`
-	    if [ "$INTERFACE" = "$DEVICE" ]; then
-		break 2
-	    fi
-	done
-	exit
-    done
-fi
-
-wpa_supplicant=/sbin/wpa_supplicant
-wpa_cli=/sbin/wpa_cli
-ip=/bin/ip
-
-# Used by the wpa_interface_* functions in the wireless.conf file
-wpa_cli_set(){
-    case "$1" in
-        ssid|psk) arg="\"$2\"" ;;
-        *) arg="$2" ;;
-    esac
-    "$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" set_network "$NETWORK" \
-	"$1" "$arg" 2>&1 | sed -e '/^OK$/d'
-}
-
-if [ $VERBOSITY -gt 0 ]; then
-    WPAS_OPTIONS="-d $WPAS_OPTIONS"
-fi
-if [ -n "$PIDFILE" ]; then
-    WPAS_OPTIONS="-P$PIDFILE $WPAS_OPTIONS"
-fi
-
-case "${MODE:-$1}" in
-    start)
-	mkdir -m u=rwx,go= -p "$CTRLDIR"
-	"$wpa_supplicant" -B -g "$CTRL" -p "$CTRLDIR" $WPAS_OPTIONS
-        for KEY in $ifkeys; do
-	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
-	    INTERFACE=`addrtoif "$ADDRESS"`
-	    DRIVER=`eval 'echo "$WPA_DRIVER_'"$KEY"\"`
-	    IFDELAY=`eval 'echo "$DELAY_'"$KEY"\"`
-	    "$wpa_cli" -g "$CTRL" interface_add "$INTERFACE" "" \
-		"${DRIVER:-wext}" "$CTRLDIR" > /dev/null \
-		| sed -e '/^OK$/d'
-	    NETWORK=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" add_network`
-	    eval wpa_interface_"$KEY"
-	    "$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" enable_network \
-		"$NETWORK" | sed -e '/^OK$/d'
-	    sleep "${IFDELAY:-$DELAY}" &
-	    sleep=$!
-	    while :; do
-		kill -0 $sleep 2>/dev/null || break
-		STATE=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" status | sed -n -e 's/^wpa_state=//p'`
-		if [ "$STATE" = COMPLETED ]; then
-		    while :; do
-			kill -0 $sleep 2>/dev/null || break 2
-			UP=`cat /sys/class/net/"$INTERFACE"/operstate`
-			if [ "$UP" = up ]; then
-			    kill $sleep 2>/dev/null
-			    break 2
-			fi
-			sleep 1
-		    done
-		fi
-		sleep 1
-	    done &
-	    wait $sleep || :
-	    IPADDRS=`eval 'echo "$IPADDRS_'"$KEY"\"`
-	    if [ -n "$IPADDRS" ]; then
-		if [ "$IPADDRS" = dhcp ]; then
-		    ipconfig -c dhcp -d "$INTERFACE" || :
-		    #dhclient "$INTERFACE"
-		else
-		    for ipaddr in $IPADDRS; do
-			"$ip" addr add "$ipaddr" dev "$INTERFACE"
-		    done
-		fi
-	    fi
-	    ROUTES=`eval 'echo "$ROUTES_'"$KEY"\"`
-	    if [ -n "$ROUTES" ]; then
-		for route in $ROUTES; do
-		    "$ip" route add "$route" dev "$BRIDGE"
-		done
-	    fi
-        done
-	;;
-    stop)
-	"$wpa_cli" -g "$CTRL" terminate 2>&1 | sed -e '/^OK$/d'
-        for KEY in $ifkeys; do
-	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
-	    INTERFACE=`addrtoif "$ADDRESS"`
-	    "$ip" addr show scope global permanent dev "$INTERFACE" \
-		| while read type addr rest; do
-		case "$type" in
-		    inet|inet6)
-			"$ip" addr del "$addr" dev "$INTERFACE"
-			;;
-		esac
-	    done
-	    "$ip" link set dev "$INTERFACE" down
-	done
-	;;
-    files)
-	echo "$wpa_supplicant"
-	echo "$wpa_cli"
-	echo "$ip"
-	;;
-    modules)
-	if [ "$IPADDRS" = dhcp ]; then
-	    echo af_packet
-	fi
-	sed -n -e 's/#.*$//' -e 's/[ 	]*$//' \
-	    -e 's/^MODULE_[^=]\+=//p' "$CONFIG"
-	;;
-esac

=== removed file 'network-hooks.d/wireless.conf'
--- network-hooks.d/wireless.conf	2011-12-31 13:25:58 +0000
+++ network-hooks.d/wireless.conf	1970-01-01 00:00:00 +0000
@@ -1,23 +0,0 @@
-# Extra options for wpa_supplicant, if any
-#WPAS_OPTIONS=""
-
-# wlan0
-ADDRESS_0=00:11:22:33:44:55
-MODULE_0=ath9k
-#WPA_DRIVER_0=wext
-wpa_interface_0(){
-    # Use this format to set simple things:
-    wpa_cli_set ssid home
-    wpa_cli_set psk "secret passphrase"
-    # Use this format to do more complex things with wpa_cli:
-    #"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" bssid "$NETWORK" 00:11:22:33:44:55
-    #"$wpa_cli" -g "$CTRL" ping
-}
-#DELAY_0=10
-IPADDRS_0=dhcp
-#IPADDRS_0="192.0.2.3/24 2001:DB8::aede:48ff:fe71:f6f2/32"
-#ROUTES_0="192.0.2.0/24 2001:DB8::/32"
-
-#ADDRESS_1=11:22:33:44:55:66
-#MODULE_1=...
-#...

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2011-12-25 00:40:09 +0000
+++ plugin-runner.c	2011-11-24 21:12:35 +0000
@@ -171,7 +171,6 @@
 }
 
 /* Helper function for add_argument and add_environment */
-__attribute__((nonnull))
 static bool add_to_char_array(const char *new, char ***array,
 			      int *len){
   /* Resize the pointed-to array to hold one more pointer */
@@ -200,7 +199,6 @@
 }
 
 /* Add to a plugin's argument vector */
-__attribute__((nonnull(2)))
 static bool add_argument(plugin *p, const char *arg){
   if(p == NULL){
     return false;
@@ -209,7 +207,6 @@
 }
 
 /* Add to a plugin's environment */
-__attribute__((nonnull(2)))
 static bool add_environment(plugin *p, const char *def, bool replace){
   if(p == NULL){
     return false;
@@ -289,7 +286,6 @@
 }
 
 /* Prints out a password to stdout */
-__attribute__((nonnull))
 static bool print_out_password(const char *buffer, size_t length){
   ssize_t ret;
   for(size_t written = 0; written < length; written += (size_t)ret){
@@ -303,7 +299,6 @@
 }
 
 /* Removes and free a plugin from the plugin list */
-__attribute__((nonnull))
 static void free_plugin(plugin *plugin_node){
   
   for(char **arg = plugin_node->argv; *arg != NULL; arg++){
@@ -421,7 +416,6 @@
     { .name = NULL }
   };
   
-  __attribute__((nonnull(3)))
   error_t parse_opt(int key, char *arg, struct argp_state *state){
     errno = 0;
     switch(key){

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2011-12-24 23:17:02 +0000
+++ plugins.d/askpass-fifo.c	2011-10-05 16:00:56 +0000
@@ -46,7 +46,6 @@
 
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-12-30 18:48:49 +0000
+++ plugins.d/mandos-client.c	2011-11-28 22:18:37 +0000
@@ -170,14 +170,11 @@
 
 /* Function to use when printing errors */
 void perror_plus(const char *print_text){
-  int e = errno;
   fprintf(stderr, "Mandos plugin %s: ",
 	  program_invocation_short_name);
-  errno = e;
   perror(print_text);
 }
 
-__attribute__((format (gnu_printf, 2, 3)))
 int fprintf_plus(FILE *stream, const char *format, ...){
   va_list ap;
   va_start (ap, format);
@@ -205,13 +202,13 @@
 }
 
 /* Add server to set of servers to retry periodically */
-bool add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
-		int af){
+int add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
+	       int af){
   int ret;
   server *new_server = malloc(sizeof(server));
   if(new_server == NULL){
     perror_plus("malloc");
-    return false;
+    return -1;
   }
   *new_server = (server){ .ip = strdup(ip),
 			  .port = port,
@@ -219,7 +216,7 @@
 			  .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
-    return false;
+    return -1;
   }
   /* Special case of first server */
   if (mc.current_server == NULL){
@@ -236,9 +233,9 @@
   ret = clock_gettime(CLOCK_MONOTONIC, &mc.current_server->last_seen);
   if(ret == -1){
     perror_plus("clock_gettime");
-    return false;
+    return -1;
   }
-  return true;
+  return 0;
 }
 
 /* 
@@ -1033,11 +1030,8 @@
       if(ret == 0){
 	avahi_simple_poll_quit(mc.simple_poll);
       } else {
-	if(not add_server(ip, port, interface,
-			  avahi_proto_to_af(proto))){
-	  fprintf_plus(stderr, "Failed to add server \"%s\" to server"
-		       " list\n", name);
-	}
+	ret = add_server(ip, port, interface,
+			 avahi_proto_to_af(proto));
       }
     }
   }
@@ -1450,7 +1444,7 @@
 	  perror_plus("setenv");
 	  _exit(EX_OSERR);
 	}
-	ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
+	ret = setenv("VERBOSE", debug ? "1" : "0", 1);
 	if(ret == -1){
 	  perror_plus("setenv");
 	  _exit(EX_OSERR);
@@ -1473,17 +1467,8 @@
 	  _exit(EX_OSERR);
 	}
 	free(delaystring);
-	if(connect_to != NULL){
-	  ret = setenv("CONNECT", connect_to, 1);
-	  if(ret == -1){
-	    perror_plus("setenv");
-	    _exit(EX_OSERR);
-	  }
-	}
-	if(execl(fullname, direntry->d_name, mode, NULL) == -1){
-	  perror_plus("execl");
-	  _exit(EXIT_FAILURE);
-	}
+	ret = execl(fullname, direntry->d_name, mode, NULL);
+	perror_plus("execl");
       } else {
 	int status;
 	if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
@@ -1608,7 +1593,7 @@
 	.group = 2 },
       { .name = "retry", .key = 132,
 	.arg = "SECONDS",
-	.doc = "Retry interval used when denied by the Mandos server",
+	.doc = "Retry interval used when denied by the mandos server",
 	.group = 2 },
       { .name = "network-hook-dir", .key = 133,
 	.arg = "DIR",
@@ -1686,6 +1671,8 @@
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
       case 'V':			/* --version */
+	fprintf_plus(state->out_stream,
+		     "Mandos plugin mandos-client: ");
 	fprintf_plus(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);
 	break;

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2011-12-27 03:56:39 +0000
+++ plugins.d/mandos-client.xml	2011-11-27 14:44:28 +0000
@@ -583,23 +583,7 @@
 	  <listitem>
 	    <para>
 	      This will be the same as the <option>--delay</option>
-	      option passed to <command>&COMMANDNAME;</command>.  Is
-	      only set if <envar>MODE</envar> is
-	      <quote><literal>start</literal></quote> or
-	      <quote><literal>stop</literal></quote>.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><envar>CONNECT</envar></term>
-	  <listitem>
-	    <para>
-	      This will be the same as the <option>--connect</option>
-	      option passed to <command>&COMMANDNAME;</command>.  Is
-	      only set if <option>--connect</option> is passed and
-	      <envar>MODE</envar> is
-	      <quote><literal>start</literal></quote> or
-	      <quote><literal>stop</literal></quote>.
+	      option passed to <command>&COMMANDNAME;</command>.
 	    </para>
 	  </listitem>
 	</varlistentry>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2011-12-25 00:40:09 +0000
+++ plugins.d/password-prompt.c	2011-10-09 12:32:13 +0000
@@ -72,18 +72,7 @@
 /* Needed for conflict resolution */
 const char plymouth_name[] = "plymouthd";
 
-__attribute__((format (gnu_printf, 2, 3), nonnull(1)))
-int fprintf_plus(FILE *stream, const char *format, ...){
-  va_list ap;
-  va_start (ap, format);
-  
-  TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
-			     program_invocation_short_name));
-  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
-}
-
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;
@@ -96,7 +85,8 @@
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);
-    fprintf(stderr, ": %s\n", strerror(errnum));
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
     error(status, errno, "vasprintf while printing error");
     return;
   }
@@ -119,7 +109,6 @@
      from the terminal.  Password-prompt will exit if it detects
      plymouth since plymouth performs the same functionality.
    */
-  __attribute__((nonnull))
   int is_plymouth(const struct dirent *proc_entry){
     int ret;
     int cl_fd;
@@ -139,7 +128,7 @@
     ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
 		   proc_entry->d_name);
     if(ret == -1){
-      error_plus(0, errno, "asprintf");
+      error(0, errno, "asprintf");
       return 0;
     }
     
@@ -148,7 +137,7 @@
     free(cmdline_filename);
     if(cl_fd == -1){
       if(errno != ENOENT){
-	error_plus(0, errno, "open");
+	error(0, errno, "open");
       }
       return 0;
     }
@@ -165,7 +154,7 @@
 	if(cmdline_len + blocksize + 1 > cmdline_allocated){
 	  tmp = realloc(cmdline, cmdline_allocated + blocksize + 1);
 	  if(tmp == NULL){
-	    error_plus(0, errno, "realloc");
+	    error(0, errno, "realloc");
 	    free(cmdline);
 	    close(cl_fd);
 	    return 0;
@@ -178,7 +167,7 @@
 	sret = read(cl_fd, cmdline + cmdline_len,
 		    cmdline_allocated - cmdline_len);
 	if(sret == -1){
-	  error_plus(0, errno, "read");
+	  error(0, errno, "read");
 	  free(cmdline);
 	  close(cl_fd);
 	  return 0;
@@ -187,7 +176,7 @@
       } while(sret != 0);
       ret = close(cl_fd);
       if(ret == -1){
-	error_plus(0, errno, "close");
+	error(0, errno, "close");
 	free(cmdline);
 	return 0;
       }
@@ -223,7 +212,7 @@
   int ret;
   ret = scandir("/proc", &direntries, is_plymouth, alphasort);
   if (ret == -1){
-    error_plus(1, errno, "scandir");
+    error(1, errno, "scandir");
   }
   free(direntries);
   return ret > 0;
@@ -260,7 +249,6 @@
       { .name = NULL }
     };
     
-    __attribute__((nonnull(3)))
     error_t parse_opt (int key, char *arg, struct argp_state *state){
       errno = 0;
       switch (key){
@@ -302,7 +290,7 @@
     case ENOMEM:
     default:
       errno = ret;
-      error_plus(0, errno, "argp_parse");
+      error(0, errno, "argp_parse");
       return EX_OSERR;
     case EINVAL:
       return EX_USAGE;
@@ -326,7 +314,7 @@
   
   if(tcgetattr(STDIN_FILENO, &t_old) != 0){
     int e = errno;
-    error_plus(0, errno, "tcgetattr");
+    error(0, errno, "tcgetattr");
     switch(e){
     case EBADF:
     case ENOTTY:
@@ -339,17 +327,17 @@
   sigemptyset(&new_action.sa_mask);
   ret = sigaddset(&new_action.sa_mask, SIGINT);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGHUP);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGTERM);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   /* Need to check if the handler is SIG_IGN before handling:
@@ -358,37 +346,37 @@
   */
   ret = sigaction(SIGINT, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
@@ -402,7 +390,7 @@
   t_new.c_lflag &= ~(tcflag_t)ECHO;
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
     int e = errno;
-    error_plus(0, errno, "tcsetattr-echo");
+    error(0, errno, "tcsetattr-echo");
     switch(e){
     case EBADF:
     case ENOTTY:
@@ -472,7 +460,7 @@
 	sret = write(STDOUT_FILENO, buffer + written, n - written);
 	if(sret < 0){
 	  int e = errno;
-	  error_plus(0, errno, "write");
+	  error(0, errno, "write");
 	  switch(e){
 	  case EBADF:
 	  case EFAULT:
@@ -494,7 +482,7 @@
       sret = close(STDOUT_FILENO);
       if(sret == -1){
 	int e = errno;
-	error_plus(0, errno, "close");
+	error(0, errno, "close");
 	switch(e){
 	case EBADF:
 	  status = EX_OSFILE;
@@ -510,7 +498,7 @@
     if(sret < 0){
       int e = errno;
       if(errno != EINTR and not feof(stdin)){
-	error_plus(0, errno, "getline");
+	error(0, errno, "getline");
 	switch(e){
 	case EBADF:
 	  status = EX_UNAVAILABLE;
@@ -539,7 +527,7 @@
     fprintf(stderr, "Restoring terminal attributes\n");
   }
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
-    error_plus(0, errno, "tcsetattr+echo");
+    error(0, errno, "tcsetattr+echo");
   }
   
   if(quit_now){
@@ -547,7 +535,7 @@
     old_action.sa_handler = SIG_DFL;
     ret = sigaction(signal_received, &old_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
     }
     raise(signal_received);
   }

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2011-12-25 00:40:09 +0000
+++ plugins.d/plymouth.c	2011-10-05 16:00:56 +0000
@@ -75,7 +75,6 @@
 }
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;
@@ -154,7 +153,6 @@
   return true;
 }
 
-__attribute__((nonnull (2, 3)))
 bool exec_and_wait(pid_t *pid_return, const char *path,
 		   const char **argv, bool interruptable,
 		   bool daemonize){
@@ -214,7 +212,6 @@
   return false;
 }
 
-__attribute__((nonnull))
 int is_plymouth(const struct dirent *proc_entry){
   int ret;
   {

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2011-11-12 18:14:55 +0000
+++ plugins.d/plymouth.xml	2011-10-05 16:00:56 +0000
@@ -161,7 +161,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename class="directory">/proc</filename></term>
+	<term><filename>/proc</filename></term>
 	<listitem>
 	  <para>
 	    To find the running <citerefentry><refentrytitle

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2011-12-24 23:17:02 +0000
+++ plugins.d/splashy.c	2011-10-05 16:00:56 +0000
@@ -61,7 +61,6 @@
 int signal_received;
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2011-12-24 23:17:02 +0000
+++ plugins.d/usplash.c	2011-10-05 16:00:56 +0000
@@ -58,7 +58,6 @@
 const char usplash_name[] = "/sbin/usplash";
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2011-11-12 18:14:55 +0000
+++ plugins.d/usplash.xml	2011-10-05 16:00:56 +0000
@@ -178,7 +178,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename class="directory">/proc</filename></term>
+	<term><filename>/proc</filename></term>
 	<listitem>
 	  <para>
 	    To find the running <citerefentry><refentrytitle

